#ifndef __I2C_H__
#define __I2C_H__

//	Pin-Definitionen
#define	I2C_SCL_w_port		PORTD
#define	I2C_SCL_r_port		PIND
#define	I2C_SCL_dir			DDRD
#define	I2C_SCL_bit			6

#define	I2C_SDA_w_port		PORTB
#define	I2C_SDA_r_port		PINB
#define	I2C_SDA_dir			DDRB
#define	I2C_SDA_bit			4

//	Makros
#define	set_I2C_SCL_dir		set_bit(I2C_SCL_dir, I2C_SCL_bit)
#define	clear_I2C_SCL_dir	clear_bit(I2C_SCL_dir, I2C_SCL_bit)
#define	set_I2C_SCL			set_bit(I2C_SCL_w_port, I2C_SCL_bit)
#define	clear_I2C_SCL		clear_bit(I2C_SCL_w_port, I2C_SCL_bit)

#define	set_I2C_SDA_dir		set_bit(I2C_SDA_dir, I2C_SDA_bit)
#define	clear_I2C_SDA_dir	clear_bit(I2C_SDA_dir, I2C_SDA_bit)
#define	set_I2C_SDA			set_bit(I2C_SDA_w_port, I2C_SDA_bit)
#define	clear_I2C_SDA		clear_bit(I2C_SDA_w_port, I2C_SDA_bit)

//	Ist 0xA0, wenn die 3 Adress-Pins des 24C64 auf HIGH geschaltete sind
#define	I2C_Device_ID		0xA0

//	Dieser Wert sollte nicht verringert werden, ansonsten kann es zu Fehlern in der Datenbertragung kommen!
#define I2C_Delay_us		900

// 	Funktionen
extern void i2c_init();
extern void i2c_start();
extern void i2c_stop();
extern void i2c_put_byte(unsigned char byte);
extern unsigned char i2c_get_byte(unsigned char ack);
extern void i2c_write(const prog_char *str, unsigned char msb, unsigned char lsb, int len);
extern unsigned char i2c_locate(unsigned char msb, unsigned char lsb);
extern void i2c_init_block_read();

//	Strings
extern const prog_char error_i2c[];

#endif
